Subject: bug#50269: 27.2; Request: use GTK continuous scroll events for smooth touchpad scrolling

From: Eli Zaretskii <[email-masked]>
Date: Wed, 01 Sep 2021 16:49:39 +0300

> From: Alexander Huntley <[email-masked]>
> Cc: Kévin Le Gouguec <[email-masked]>,
>  [email-masked]
> Date: Wed, 1 Sep 2021 13:57:46 +0100
> 
> > So if pixel-resolution-fine-flag is set, the behavior is the expected
> > one, and we can conclude that Emacs passes this test?
> 
> If the flag is set to 1, then yes the scrolling works as desired, but only
> when scrolling with the touchpad slowly (although perhaps it is scrolling
> by 2 or 3 pixels instead of only 1).

That's good to hear, thanks.

> When scrolling quickly, Emacs scrolls abruptly by many lines at a
> time, which is not what we want. I'm sure this is possible to disable.

I'm guessing that the touchpad has some customization control, which
could control how it reports fast scrolling to applications.  Emacs
has similar controls in the variables mouse-wheel-scroll-amount and
mouse-wheel-progressive-speed.  I suggest to try playing with these
Emacs options and perhaps also with your touchpad controls, and try to
find the configuration that supports fast scrolling as well.

> IMO the best way to solve this would be to use GTK scrolling events. They
> give the correct magnitude of the scroll event (which in touchpads is
> variable and much smaller than for mouse wheels). Hence Emacs would not
> have to distinguish between mouse vs touchpad scrolling; it would all
> be handled by GTK.

AFAIU, this can only be possible in the upcoming PGTK configuration of
Emacs, if at all.  But I urge you to try customizing the options I
mentioned above, because perhaps you could have what you want much
sooner and easier than by waiting for PGTK to hit the streets.